#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#include<math.h>
#include<time.h>
#include "allocate.h"
#include "pxm.h"

#define ABS(x) (((x) > 0) ? (x):-(x) )
/*#define SEGMENTATION_MAP*/

struct fOptSigSet
{
    int nbands;
    struct fOptClassSig
    {
        int nsubclasses;
        float variance;
        float inv_variance;
        struct fOptSubSig
        {
            float pi;
	    float cnst;
            float *means;
            float **R;
            float **Rinv;
        } *OptSubSig;
    } *OptClassSig;
};

/* interp_util.c routines */
void read_classifier_filter( 
 char *fname, 
 struct fOptSigSet **OS,
 int *interp_factor, 
 int *W, 
 int *P,
 int *interp_clust_length, 
 int *filt_length, 
 int *high_res_length, 
 float *clust_vec_power, 
 float ***joint_means, 
 float ****filter);

void MakeLuminanceArray (
  struct pxm_img *lum_img, 
  struct pxm_img *img);

void get_den_clust_vector(
  unsigned char **lum_array,
  float *vector,
  float power,
  int W, int i, int j,
  int height, int width);

void get_enh_clust_vector(
  unsigned char **lum_array,
  float *vector,
  float power,
  int W, int i, int j,
  int height, int width);

void put_high_res_pixels(
  unsigned char **imgh,
  unsigned char **imgl,
  int interp_factor,
  int i,
  int j,
  float *vector);

void GetLowResPixels ( 
  unsigned char **img, float *vector,
  int P, int i, int j, 
  int height, int width );

int choose_classes ( 
  int *filt_indices, float sigma_factor,
  float *prob, float *vector,
  struct fOptClassSig *OptClassSig, 
  int vec_length,int *max );

int max_prob(
  float *prob, 
  int M);

void read_pxm_img( 
  char *fname,
  struct pxm_img *img );

void write_pxm_img( 
  char *fname,
  struct pxm_img *img );

void get_pxm( 
  struct pxm_img *img,
  int height,
  int width,
  char type );

void convertPGMtoPPM ( 
  struct pxm_img *img );

void convertPPMtoPGM ( 
  struct pxm_img *img );

/* preprocess.c */
void apply_gauss_filter(
  struct pxm_img *in_img,
  struct pxm_img *out_img,
  float  std_dev,
  int    mask_size);












